/* ========================================== op.media.dat.h ============================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                        Author: Glen Petrie                                               */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2011-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing                                                                      */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __OPEN_PRINTING_MEDIA_DAT_H__
#define __OPEN_PRINTING_MEDIA_DAT_H__

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "gp.typedefs.h"

/*--------------------------------------------- Data Types ------------------------------------------------ */
/* ..................................................|..................................................... */

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */
    /*** Media Size                                                                                         */
    /*** .................................................................................................. */
typedef enum {
    OP_MD_NOT_SET,
    OP_MD_RSV1,

/*** North American Media Sizes                                                                             */
/* -------------------------------------------------------------------------------------------------------- */
    NA_MEDIA_SIZE_LABEL,

    /* SMALL_MEDIA   Media Widths <  3.93" (100 mm)                                                         */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    NA_INDEX_3X5_3X5IN,
    NA_PERSONAL_3o625X6o5IN,
    NA_MONARCH_3o875X7o5IN,
    NA_NUMBER_9_3o875X8o875IN,

    /* NOMINAL_MEDIA  Media Widths => 3.93"(100mm) & <= 9.61"(244mm)                                        */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    NA_INDEX_4X6_4X6IN,
    NA_NUMBER_10_4o125X9o5IN,
    NA_A2_4o375X5o75IN,
    NA_NUMBER_11_4o5X10o375IN,/**/
    NA_NUMBER_12_4o75X11IN,
    NA_5X7_5X7IN,
    NA_INDEX_5X8_5X8IN,
    NA_NUMBER_14_5X11o5IN,
    NA_INVOICE_5o5X8o5IN,
    NA_INDEX_4X6_EXT_6X8IN,
    NA_6X9_6X9IN,
    NA_C5_6o5X9o5IN,
    NA_7X9_7X9IN,
    NA_EXECUTIVE_7o25X10o5IN,/**/
    NA_GOVT_LETTER_8X10IN,
    NA_GOVT_LEGAL_8X13IN,
    NA_QUARTO_8o5X10o83IN,
    NA_LETTER_8o5X11IN,
    NA_FANFOLD_EUR_8o5X12IN,
    NA_LETTER_PLUS_8o5X12o69IN,
    NA_FOOLSCAP_8o5X13IN,
    NA_LEGAL_8o5X14IN,
    NA_SUPER_A_8o94X14IN,
    NA_9X11_9X11IN,/**/
    NA_ARCH_A_9X12IN,
    NA_LETTER_EXTRA_9o5X12IN,/**/
    NA_LEGAL_EXTRA_9o5X15IN,/*1*/

    /* LARGE_MEDIA  Media Widths >  9.61" (244 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    NA_10X11_10X11IN,
    NA_10X13_10X13IN,
    NA_10X14_10X14IN,
    NA_10X15_10X15IN,
    NA_11X12_11X12IN,
    NA_EDP_11X14IN,
    NA_FANFOLD_US_11X14o875IN,
    NA_11X15_11X15IN,
    NA_LEDGER_11X17IN,/**/
    NA_EUR_EDP_12X14IN,
    NA_ARCH_B_12X18IN,
    NA_12X19_12X19IN,
    NA_B_PLUS_12X19o17IN,
    NA_SUPER_B_13X19IN,
    NA_C_17X22IN,
    NA_ARCH_C_18X24IN,
    NA_D_22X34IN,
    NA_ARCH_D_24X36IN,
    ASME_F_28X40IN,/**/
    NA_WIDE_FORMAT_30X42IN,
    NA_E_34X44IN,

/*** Chinese Media Sizes                                                                                    */
/* -------------------------------------------------------------------------------------------------------- */
    PRC_MEDIA_SIZE_LABEL,

    /* SMALL_MEDIA  Media Widths <  3.93" (100 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    PRC_32K_97X151MM,

    /* NOMINAL_MEDIA  Media Widths => 3.93"(100mm) & <= 9.61"(244mm)                                        */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    PRC_1_102X165MM,
    PRC_2_102X176MM,
    PRC_4_110X208MM,
    PRC_5_110X220MM,
    PRC_8_120X309MM,
    PRC_6_120X320MM,
    PRC_3_125X176MM,/**/
    PRC_16K_146X215MM,
    PRC_7_160X230MM,/**/
    ROC_16K_7o75X10o75IN,/*2*/
    OM_JUURO_KU_KAI_198X275MM,

    /* LARGE_MEDIA  Media Widths >  9.61" (244 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    OM_PA_KAI_267X389MM,
    ROC_8K_10o75X15o5IN,
    OM_DAI_PA_KAI_275X395MM,
    RC_10_324X458MM,

    /*** IOS Standard Sheet (Media) Media Sizes                                                             */
    /* ---------------------------------------------------------------------------------------------------- */
    ISO_MEDIA_SIZE_LABEL,

    /* SMALL_MEDIA  Media Widths <  3.93" (100 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    ISO_A10_26X37MM,
    ISO_A9_37X52MM,
    ISO_A8_52X74MM,
    ISO_A7_74X105MM,
    ISO_B10_31X44MM,/**/
    ISO_B9_44X62MM,
    ISO_B8_62X88MM,
    ISO_B7_88X125MM,
    ISO_C10_28X40MM,
    ISO_C9_40X57MM,
    ISO_C8_57X81MM,
    ISO_C7_81X114MM,
    ISO_C7C6_81X162MM,

    /* NOMINAL_MEDIA  Media Widths => 3.93"(100mm) & <= 9.61"(244mm)                                        */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    ISO_A6_105X148MM,
    ISO_A5_148X210MM,/**/
    ISO_A5_EXTRA_174X235MM,
    ISO_A4_210X297MM,
    ISO_A4_TAB_225X297MM,
    ISO_A4_EXTRA_235o5X322o3MM,
    ISO_B6_125X176MM,
    ISO_B6C4_125X324MM,
    ISO_B5_176X250MM,
    ISO_B5_EXTRA_201X276MM,
    ISO_DL_110X220MM,
    ISO_C6_114X162MM,/**/
    ISO_C6C5_114X229MM,
    ISO_C5_162X229MM,/**/

    /* LARGE_MEDIA  Media Widths >  9.61" (244 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    ISO_A3_297X420MM,/*3*/
    ISO_A4X3_297X630MM,
    ISO_A4X4_297X841MM,
    ISO_A4X5_297X1051MM,
    ISO_A3_EXTRA_322X445MM,
    ISO_A2_420X594MM,
    ISO_A3X3_420X891MM,
    ISO_A1_594X841MM,
    ISO_B4_250X353MM,
    ISO_B3_353X500MM,/**/
    ISO_B2_500X707MM,
    ISO_B1_707X1000MM,
    ISO_C4_229X324MM,
    ISO_C3_324X458MM,
    ISO_RA2_430X610MM,
    ISO_SRA2_450X640MM,
    ISO_C2_458X648MM,
    ISO_RA1_610X860MM,
    ISO_SRA1_640X900MM,
    ISO_C1_648X917MM,/**/
    ISO_C0_917X1297MM,

    /*** Japanese Standard Media Sizes                                                                      */
    /* ---------------------------------------------------------------------------------------------------- */
    JIS_MEDIA_SIZE_LABEL,

    /* SMALL_MEDIA  Media Widths <  3.93" (100 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    JIS_B10_32X45MM,
    JIS_B9_45X64MM,
    JIS_B8_64X91MM,
    JIS_B7_91X128MM,
    JPN_CHOU4_90X205MM,

    /* NOMINAL_MEDIA  Media Widths => 3.93"(100mm) & <= 9.61"(244mm)                                        */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    JPN_HAGAKI_100X148MM,
    JIS_B6_128X182MM,
    JIS_B5_182X257MM,
    JIS_EXEC_216X330MM,/**/
    JPN_YOU4_105X235MM,
    JPN_CHOU2_111o1X146MM,/**/
    JPN_CHOU3_120X235MM,/*4*/
    JPN_OUFUKU_148X200MM,
    JPN_KAHU_240X322o1MM,
    JPN_KAKU2_240X332MM,

    /* LARGE_MEDIA  Media Widths >  9.61" (244 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    JIS_B4_257X364MM,
    JIS_B3_364X515MM,
    JIS_B2_515X728MM,
    JIS_B1_728X1030MM,

    /*** Misc Metric Standard Media Sizes                                                                   */
    /* ---------------------------------------------------------------------------------------------------- */
    OM_MEDIA_SIZE_LABEL,

    /* SMALL_MEDIA  Media Widths <  3.93" (100 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */

    /* NOMINAL_MEDIA  Media Widths => 3.93"(100mm) & <= 9.61"(244mm)                                        */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
    OM_SMALL_PHOTO_100X150MM,
    OM_ITALIAN_110X230MM,/**/
    OM_POSTFIX_114X229MM,
    OM_LARGE_PHOTO_200X300MM,
    OM_FOLIO_210X330MM,
    OM_FOLIO_SP_215X315MM,
    OM_INVITE_220X220MM,

    /* LARGE_MEDIA  Media Widths >  9.61" (244 mm)                                                          */
    /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */

    /* End of Standard Media Size List                                                                      */
    /* ---------------------------------------------------------------------------------------------------- */
    VENDOR_MEDIA_SIZE_LABEL,

    opMEDIA_SIZE_NUM_STD

} opMEDIA_SIZE_STD;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */
    /*** Media Type Data Struct                                                                             */
    /*** .................................................................................................. */
    /***  Media Classes:     0     1        2       3       4                                               */
    /***                   Plain  inkjet  Photo   Trans   Other                                             */
    /*** .................................................................................................. */
typedef struct {
    gpBIT8     type;                                  /* What class is the media                            */
    gpCHAR*    name;                                  /* Name of the Media type                             */
} opMEDIA_TYPE;


    /*** Media Size Data Struct                                                                             */
    /*** .................................................................................................. */
typedef struct {
    gpCHAR*    name;                                  /* Media Name including size                          */
    gpBIT32    width;                                 /* Width  of media: 2880 dpi                          */
    gpBIT32    height;                                /* Height of media: 2880 dpi                          */
} opMEDIA_SIZE;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern opMEDIA_SIZE stdMediaSize[];
extern opMEDIA_SIZE epMediaSize[];
extern opMEDIA_TYPE epMediaType[];

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#endif    /* __OPEN_PRINTING_MEDIA_DAT_H__                                                                  */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ========================================== op.media.dat.h ============================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
