/* ======================================== op.more.dialog.c ============================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                        Author: Glen Petrie                                               */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2011-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing                                                                      */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "gw.win.h"
#include "op.job.ticket.attributes.h"
#include "op.media.dat.h"
#include VENDOR_HEADER

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */
#define Show(o) \
    fprintf(stderr,"QObject: %s: %d\n", o, senderId); fflush(stderr);

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ----------------------------------- Graphic Elements for Main Window ----------------------------------- */
/* ..................................................|..................................................... */
gwFONT* font;

    /* ----------------------------  Graphic Elements for Media Dialog  ----------------------------------- */
    /* .................................................................................................... */
    gwDIALOG*       mediaDialog;

    gwLABEL*        mediaSizeLabel;
        gwDROPLIST*     mediaSizeSelect;
        gpINT32         mssdx;
        gpINT32         mediaSizeNum;
    gwLABEL*        mediaTypeLabel;
        gwDROPLIST*     mediaTypeSelect;
        gpINT32         mtsdx;
        gpINT32         mediaTypeNum;
    gwLABEL*        mediaColorLabel;
        gwDROPLIST*     mediaColorSelect;
        gpINT32         mcsdx;
        gpINT32         mediaColorNum;
    gwLABEL*        mediaPreprintedLabel;
        gwDROPLIST*     mediaPreprintedSelect;
        gpINT32         mpsdx;
        gpINT32         mediaPreprintedNum;
    gwLABEL*        mediaInputTrayLabel;
        gwDROPLIST*     mediaInputTraySelect;
        gpINT32         misdx;
        gpINT32         mediaInputTrayNum;

    /* --------------------------  Graphic Elements for Quality Dialog  ----------------------------------- */
    /* .................................................................................................... */
    gwDIALOG*       qualityDialog;

    gwLABEL*        qualityContentLabel;
        gwDROPLIST*     qualityContentSelect;
        gpINT32         qcsdx;
        gpINT32         qualityContentNum;
    gwLABEL*        qualityQualityLabel;
        gwDROPLIST*     qualityQualitySelect;
        gpINT32         qqsdx;
        gpINT32         qualityQualityNum;
    gwLABEL*        qualityDpiLabel;
        gwDROPLIST*     qualityDpiSelect;
        gpINT32         qdsdx;
        gpINT32         qualityDpiNum;
    gwLABEL*        qualityColorSystemLabel;
        gwDROPLIST*     qualityColorSystemSelect;
        gpINT32         qcssdx;
        gpINT32         qualityColorSystemNum;

    /* --------------------------  Graphic Elements for Print Area Dialog  -------------------------------- */
    /* .................................................................................................... */
    gwDIALOG*       printAreaDialog;
#if 0
    gwLABEL*        printAreaMarginLabel;
        gwDROPLIST*     printAreaSelect;
    gwLABEL*        qualityQualityLabel;
        gwDROPLIST*     qualityQualitySelect;
    gwLABEL*        qualityDpiLabel;
        gwDROPLIST*     qualityDpiSelect;
    gwLABEL*        qualityColorSystemLabel;
        gwDROPLIST*     qualityColorSystemSelect;
#endif
    /* ----------------------------  Graphic Elements for Output Dialog  ---------------------------------- */
    /* .................................................................................................... */
    gwDIALOG*       outputDialog;

    gwLABEL*        outputBinLabel;
        gwDROPLIST*     outputBinSelect;
        gpINT32         obsdx;
        gpINT32         outputBinNum;
    gwLABEL*        outputJogLabel;
        gwDROPLIST*     outputJogSelect;
        gpINT32         ojsdx;
        gpINT32         outputJogNum;
    gwLABEL*        outputSeparatorLabel;
        gwDROPLIST*     outputSeparatorSelect;
        gpINT32         ossdx;
        gpINT32         outputSeparatorNum;
    gwLABEL*        outputCollateLabel;
        gwDROPLIST*     outputCollateSelect;
        gpINT32         ocsdx;
        gpINT32         outputCollateNum;

    /* -------------------------  Graphic Elements for Finishing Dialog  ---------------------------------- */
    /* .................................................................................................... */
    gwDIALOG*       finishingDialog;

    gwLABEL*        finishingFoldingLabel;
        gwDROPLIST*     finishingFoldingSelect;
        gpINT32         ffsdx;
        gpINT32         finishingFoldingNum;
    gwLABEL*        finishingStitchingLabel;
        gwDROPLIST*     finishingStitchingSelect;
        gpINT32         fssdx;
        gpINT32         finishingStitchingNum;
    gwLABEL*        finishingBindingLabel;
        gwDROPLIST*     finishingBindingSelect;
        gpINT32         fbsdx;
        gpINT32         finishingBindingNum;
    gwLABEL*        finishingHolesLabel;
        gwDROPLIST*     finishingHolesSelect;
        gpINT32         fhsdx;
        gpINT32         finishingHolesNum;

    /* ------------------------  Graphic Elements for Notification Dialog  -------------------------------- */
    /* .................................................................................................... */
    gwDIALOG*       notificationDialog;

    gwLABEL*        notificationEventsLabel;
        gwDROPLIST*     notificationEventsSelect;
        gpINT32         nesdx;
        gpINT32         notificationEventsNum;
    gwLABEL*        notificationHoldLabel;
        gwDROPLIST*     notificationHoldSelect;
        gpINT32         nhsdx;
        gpINT32         notificationHoldNum;


/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */
static gpVOID _CreateMediaDialog(gwDIALOG**);
       gpVOID MediaCallBack(QObject*);

static gpVOID _CreateQualityDialog(gwDIALOG**);
       gpVOID QualityCallBack(QObject*);

static gpVOID _CreatePrintAreaDialog(gwDIALOG**);
       gpVOID PrintAreaCallBack(QObject*);

static gpVOID _CreateOutputDialog(gwDIALOG**);
       gpVOID OutputCallBack(QObject*);

static gpVOID _CreateFinishingDialog(gwDIALOG**);
       gpVOID FinishingCallBack(QObject*);

static gpVOID _CreateNotificationDialog(gwDIALOG**);
       gpVOID NotificationCallBack(QObject*);

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/* ======================================================================================================== */
/* Function name: More(...)                                                                                 */
/* ======================================================================================================== */
void More(

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Windowing                                                                                              */
/*** ------------------------------------------------------------------------------------------------------ */
    /*** Define Font for Text Labels                                                                        */
    /*** .................................................................................................. */
    font = gwFontNew(pd);
    gwFontSize(font, 11);
    gwFontBold(font);

    /*** Initialize Generic Window Variables                                                                */
    /*** ---------------------------------------------------------------------------------------------------*/
    gwSetCallBackFncNew(       MediaCallBack);
    gwSetCallBackFncNew(     QualityCallBack);
    gwSetCallBackFncNew(   PrintAreaCallBack);
    gwSetCallBackFncNew(      OutputCallBack);
    gwSetCallBackFncNew(   FinishingCallBack);
    gwSetCallBackFncNew(NotificationCallBack);

    /*** Create More... Dialog                                                                              */
    /*** -------------------------------------------------------------------------------------------------- */
    _CreateMediaDialog(              &mediaDialog);
    _CreateQualityDialog(          &qualityDialog);
    _CreatePrintAreaDialog(      &printAreaDialog);
    _CreateOutputDialog(            &outputDialog);
    _CreateFinishingDialog(      &finishingDialog);
    _CreateNotificationDialog(&notificationDialog);

    /*** Show (Display) Dialogs                                                                             */
    /*** -------------------------------------------------------------------------------------------------- */
    gwDialogShow(       mediaDialog);
    gwDialogShow(     qualityDialog);
    gwDialogShow(   printAreaDialog);
    gwDialogShow(      outputDialog);
    gwDialogShow(   finishingDialog);
    gwDialogShow(notificationDialog);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* More(...)                                                                                              */

/* ======================================================================================================== */
/* Function name: MoreClose(...)                                                                            */
/* ======================================================================================================== */
void MoreClose(

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Windowing                                                                                              */
/*** ------------------------------------------------------------------------------------------------------ */

    /*** Close Dialogs                                                                                      */
    /*** -------------------------------------------------------------------------------------------------- */
    gwDialogClose(       mediaDialog);
    gwDialogClose(     qualityDialog);
    gwDialogClose(   printAreaDialog);
    gwDialogClose(      outputDialog);
    gwDialogClose(   finishingDialog);
    gwDialogClose(notificationDialog);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* MoreClose(...)                                                                                         */

/* ======================================================================================================== */
/* Function name: MediaCallBack(...)                                                                        */
/* ======================================================================================================== */
gpVOID MediaCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;
gpINT32 lastdx;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    senderId = (gpBIT32)sender;

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Media Size                                                                                             */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)mediaSizeSelect) {
      Show("Media Size");
      gwDropListSetItemColor(mediaSizeSelect, mssdx, gwNone);
      lastdx = mssdx;
      mssdx = gwDropListGetIndex(mediaSizeSelect);
      if (stdMediaSize[mssdx].width == 0) {
        gwDropListSetItemColor(mediaSizeSelect, mssdx, gwGreen);
        mssdx = lastdx;
        gwDropListSelectItem(mediaSizeSelect,mssdx) ;
      }
      gwDropListSetItemColor(mediaSizeSelect, mssdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Media Type                                                                                             */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)mediaTypeSelect) {
      Show("Media Type");
      gwDropListSetItemColor(mediaTypeSelect, mtsdx, gwNone);
      mtsdx = gwDropListGetIndex(mediaTypeSelect);
      gwDropListSetItemColor(mediaTypeSelect, mtsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Media Color                                                                                            */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)mediaColorSelect) {
      Show("Media Color");
      gwDropListSetItemColor(mediaColorSelect, mcsdx, gwNone);
      mcsdx = gwDropListGetIndex(mediaColorSelect);
      gwDropListSetItemColor(mediaColorSelect, mcsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Media Preprinted                                                                                       */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)mediaPreprintedSelect) {
      Show("Media Preprinted");
      gwDropListSetItemColor(mediaPreprintedSelect, mpsdx, gwNone);
      mpsdx = gwDropListGetIndex(mediaPreprintedSelect);
      gwDropListSetItemColor(mediaPreprintedSelect, mpsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Media Input Tray                                                                                       */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)mediaInputTraySelect) {
      Show("Media Input Tray");
      gwDropListSetItemColor(mediaInputTraySelect, misdx, gwNone);
      misdx = gwDropListGetIndex(mediaInputTraySelect);
      gwDropListSetItemColor(mediaInputTraySelect, misdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* MediaCallBack(...)                                                                                     */

/* ======================================================================================================== */
/* Function name: QualityCallBack(...)                                                                      */
/* ======================================================================================================== */
gpVOID QualityCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    senderId = (gpBIT32)sender;

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Quality Content Type                                                                                   */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)qualityContentSelect) {
      Show("Quality Content Type");
      gwDropListSetItemColor(qualityContentSelect, qcsdx, gwNone);
      qcsdx = gwDropListGetIndex(qualityContentSelect);
      gwDropListSetItemColor(qualityContentSelect, qcsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Quality Quality                                                                                        */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)qualityQualitySelect) {
      Show("Quality Quality");
      gwDropListSetItemColor(qualityQualitySelect, qqsdx, gwNone);
      qqsdx = gwDropListGetIndex(qualityQualitySelect);
      gwDropListSetItemColor(qualityQualitySelect, qqsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Quality DPI                                                                                            */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)qualityDpiSelect) {
      Show("Quality DPI");
      gwDropListSetItemColor(qualityDpiSelect, qdsdx, gwNone);
      qdsdx = gwDropListGetIndex(qualityDpiSelect);
      gwDropListSetItemColor(qualityDpiSelect, qdsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Quality Color Space                                                                                    */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)qualityColorSystemSelect) {
      Show("Quality Color Space");
      gwDropListSetItemColor(qualityColorSystemSelect, qcssdx, gwNone);
      qcssdx = gwDropListGetIndex(qualityColorSystemSelect);
      gwDropListSetItemColor(qualityColorSystemSelect, qcssdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* QualityCallBack(...)                                                                                   */


/* ======================================================================================================== */
/* Function name: PrintAreaCallBack(...)                                                                    */
/* ======================================================================================================== */
gpVOID PrintAreaCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
//gpBIT32 senderId;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    //senderId = (gpBIT32)sender;

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Phone Display Sizes                                                                                    */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
//    if (senderId == (gpBIT32)phoneSizes) {

  //  break;
   // }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* PrintAreaCallBack(...)                                                                                 */

/* ======================================================================================================== */
/* Function name: OutputCallBack(...)                                                                       */
/* ======================================================================================================== */
gpVOID OutputCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */    senderId = (gpBIT32)sender;

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Output Bin                                                                                             */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)outputBinSelect) {
      Show("Output Bin");
      gwDropListSetItemColor(outputBinSelect, obsdx, gwNone);
      obsdx = gwDropListGetIndex(outputBinSelect);
      gwDropListSetItemColor(outputBinSelect, obsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Output Jog                                                                                             */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)outputJogSelect) {
      Show("Output Jog");
      gwDropListSetItemColor(outputJogSelect, ojsdx, gwNone);
      ojsdx = gwDropListGetIndex(outputJogSelect);
      gwDropListSetItemColor(outputJogSelect, ojsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Output Separator Sheet                                                                                 */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)outputSeparatorSelect) {
      Show("Output Separator Sheet");
      gwDropListSetItemColor(outputSeparatorSelect, ossdx, gwNone);
      ossdx = gwDropListGetIndex(outputSeparatorSelect);
      gwDropListSetItemColor(outputSeparatorSelect, ossdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Output Separator Sheet                                                                                 */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)outputCollateSelect) {
      Show("Output Collate");
      gwDropListSetItemColor(outputCollateSelect, ocsdx, gwNone);
      ocsdx = gwDropListGetIndex(outputCollateSelect);
      gwDropListSetItemColor(outputCollateSelect, ocsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* FinishingCallBack(...)                                                                                 */

/* ======================================================================================================== */
/* Function name: FinishingCallBack(...)                                                                    */
/* ======================================================================================================== */
gpVOID FinishingCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */    senderId = (gpBIT32)sender;

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Finishing Folding                                                                                      */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)finishingFoldingSelect) {
      Show("Finishing Folding");
      gwDropListSetItemColor(finishingFoldingSelect, ffsdx, gwNone);
      ffsdx = gwDropListGetIndex(finishingFoldingSelect);
      gwDropListSetItemColor(finishingFoldingSelect, ffsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Finishing Stitching                                                                                    */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)finishingStitchingSelect) {
      Show("Finishing Stitching");
      gwDropListSetItemColor(finishingStitchingSelect, fssdx, gwNone);
      fssdx = gwDropListGetIndex(finishingStitchingSelect);
      gwDropListSetItemColor(finishingStitchingSelect, fssdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Finishing Binding                                                                                      */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)finishingBindingSelect) {
      Show("Finishing Binding");
      gwDropListSetItemColor(finishingBindingSelect, fbsdx, gwNone);
      fbsdx = gwDropListGetIndex(finishingBindingSelect);
      gwDropListSetItemColor(finishingBindingSelect, fbsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Finishing Holes                                                                                        */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)finishingHolesSelect) {
      Show("Finishing Holes");
      gwDropListSetItemColor(finishingHolesSelect, fhsdx, gwNone);
      fhsdx = gwDropListGetIndex(finishingHolesSelect);
      gwDropListSetItemColor(finishingHolesSelect, fhsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* FinishingCallBack(...)                                                                                 */

/* ======================================================================================================== */
/* Function name: NotificationCallBack(...)                                                                 */
/* ======================================================================================================== */
gpVOID NotificationCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */    senderId = (gpBIT32)sender;

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Notification Events                                                                                    */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)notificationEventsSelect) {
      Show("Notification Events");
      gwDropListSetItemColor(notificationEventsSelect, nesdx, gwNone);
      nesdx = gwDropListGetIndex(notificationEventsSelect);
      gwDropListSetItemColor(notificationEventsSelect, nesdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Notification Hold                                                                                      */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)notificationHoldSelect) {
      Show("Notification Hold");
      gwDropListSetItemColor(notificationHoldSelect, nhsdx, gwNone);
      nhsdx = gwDropListGetIndex(notificationHoldSelect);
      gwDropListSetItemColor(notificationHoldSelect, nhsdx, QColor( 0xAEDCE6));
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* NotificationCallBack(...)                                                                              */

/* ======================================================================================================== */
/* Function name: _CreateMediaDialog(...)                                                                   */
/* ======================================================================================================== */
static gpVOID _CreateMediaDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwDIALOG* pd;
gpINT32   idx;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Media Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Media");
    gwDialogFrame(pd, 0, 562, 210, 350);

    /*** Media Size Label                                                                                   */
    /*** .................................................................................................. */
    mediaSizeLabel = gwLabelNew(pd);
    gwLabelTitle(mediaSizeLabel,"Media Size");
    gwLabelFrame(mediaSizeLabel, 10, 6, 160, 17);
    gwLabelFont (mediaSizeLabel, font);
    gwLabelAlign(mediaSizeLabel, gwALIGN_H_CENTER);

    /*** Media Size drop down widget                                                                        */
    /*** .................................................................................................. */
    mediaSizeSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(mediaSizeSelect, gwRed);
    for (idx = 0; idx < opMEDIA_SIZE_NUM_STD; idx++) {
        gwDropListAddItem(mediaSizeSelect, stdMediaSize[idx].name);
        if (stdMediaSize[idx].width == 0)
          gwDropListSetItemColor(mediaSizeSelect, idx, gwGreen);
    }
    for (idx = 0; idx < opMEDIA_SIZE_NUM_VENDOR; idx++)
        gwDropListAddItem(mediaSizeSelect, epMediaSize[idx].name);
    mediaSizeNum = opMEDIA_SIZE_NUM_STD + opMEDIA_SIZE_NUM_VENDOR;
    gwDropListFrame(mediaSizeSelect, 10, 25,160, windowMetric.dropList.height);
    mssdx = 0;
    gwDropListSelectItem(mediaSizeSelect,mssdx);
    gwDropListSetItemColor(mediaSizeSelect, mssdx, QColor(0xAEDCE6));
    gwConnect(MediaCallBack, mediaSizeSelect,currentIndexChanged(int));

    /*** Media Type Label                                                                                   */
    /*** .................................................................................................. */
    mediaTypeLabel = gwLabelNew(pd);
    gwLabelTitle(mediaTypeLabel,"Media Type");
    gwLabelFrame(mediaTypeLabel, 10, 66, 160, 17);
    gwLabelFont (mediaTypeLabel, font);
    gwLabelAlign(mediaTypeLabel, gwALIGN_H_CENTER);

    /*** Media Type drop down widget                                                                        */
    /*** .................................................................................................. */
    mediaTypeSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(mediaTypeSelect, gwRed);
    for (idx = 0; idx < OP_MT_EOL; idx++)
        gwDropListAddItem(mediaTypeSelect,opMedTyp[idx]);
    mediaTypeNum = idx;
    gwDropListFrame(mediaTypeSelect, 10, 85,160, windowMetric.dropList.height);
    mtsdx = 0;
    gwDropListSelectItem(mediaTypeSelect,mtsdx);
    gwDropListSetItemColor(mediaTypeSelect, mtsdx, QColor(0xAEDCE6));
    gwConnect(MediaCallBack, mediaTypeSelect,currentIndexChanged(int));

    /*** Media Color Label                                                                                  */
    /*** .................................................................................................. */
    mediaColorLabel = gwLabelNew(pd);
    gwLabelTitle(mediaColorLabel,"Media Color");
    gwLabelFrame(mediaColorLabel, 10, 126, 160, 17);
    gwLabelFont (mediaColorLabel, font);
    gwLabelAlign(mediaColorLabel, gwALIGN_H_CENTER);

    /*** Media Color drop down widget                                                                       */
    /*** .................................................................................................. */
    mediaColorSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(mediaColorSelect, gwRed);
    for (idx = 0; idx < OP_MC_EOL; idx++)
        gwDropListAddItem(mediaColorSelect,opMedClr[idx]);
    mediaColorNum = idx;
    gwDropListFrame(mediaColorSelect, 10, 145,160, windowMetric.dropList.height);
    mcsdx = 0;
    gwDropListSelectItem(mediaColorSelect, mcsdx);
    gwDropListSetItemColor(mediaColorSelect, mcsdx, QColor(0xAEDCE6));
    gwConnect(MediaCallBack, mediaColorSelect,currentIndexChanged(int));

    /*** Media Color Label                                                                                  */
    /*** .................................................................................................. */
    mediaPreprintedLabel = gwLabelNew(pd);
    gwLabelTitle(mediaPreprintedLabel,"Media Pre-Printed");
    gwLabelFrame(mediaPreprintedLabel, 10, 186, 160, 17);
    gwLabelFont (mediaPreprintedLabel, font);
    gwLabelAlign(mediaPreprintedLabel, gwALIGN_H_CENTER);

    /*** Media Preprinted drop down widget                                                                  */
    /*** .................................................................................................. */
    mediaPreprintedSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(mediaPreprintedSelect, gwRed);
    for (idx = 0; idx < OP_MP_EOL; idx++)
        gwDropListAddItem(mediaPreprintedSelect, opMedPre[idx]);
    mediaPreprintedNum = idx;
    gwDropListFrame(mediaPreprintedSelect, 10, 205,160, windowMetric.dropList.height);
    mpsdx = 0;
    gwDropListSelectItem(mediaPreprintedSelect, mpsdx);
    gwDropListSetItemColor(mediaPreprintedSelect, mpsdx, QColor(0xAEDCE6));
    gwConnect(MediaCallBack, mediaPreprintedSelect,currentIndexChanged(int));

    /*** Media Input Tray Label                                                                             */
    /*** .................................................................................................. */
    mediaInputTrayLabel = gwLabelNew(pd);
    gwLabelTitle(mediaInputTrayLabel,"Media Input Tray");
    gwLabelFrame(mediaInputTrayLabel, 10, 246, 160, 17);
    gwLabelFont (mediaInputTrayLabel, font);
    gwLabelAlign(mediaInputTrayLabel, gwALIGN_H_CENTER);

    /*** Media Input Tray drop down widget                                                                  */
    /*** .................................................................................................. */
    mediaInputTraySelect = gwDropListNew(pd);
    gwDropListSetSelectColor(mediaInputTraySelect, gwRed);
    for (idx = 0; idx < OP_IT_EOL; idx++)
        gwDropListAddItem(mediaInputTraySelect, opInpTry[idx]);
    mediaInputTrayNum = idx;
    gwDropListFrame(mediaInputTraySelect, 10, 265,160, windowMetric.dropList.height);
    misdx = 0;
    gwDropListSelectItem(mediaInputTraySelect, misdx);
    gwDropListSetItemColor(mediaInputTraySelect, misdx, QColor(0xAEDCE6));
    gwConnect(MediaCallBack, mediaInputTraySelect,currentIndexChanged(int));

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreateMediaDialog(...)                                                                                */

/* ======================================================================================================== */
/* Function name: _CreateQualityDialog(...)                                                                 */
/* ======================================================================================================== */
static gpVOID _CreateQualityDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwDIALOG* pd;
gpINT32   idx;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Media Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Quality");
    gwDialogFrame(pd, 214, 562, 210, 350);

    /*** Quality Content Label                                                                              */
    /*** .................................................................................................. */
    qualityContentLabel = gwLabelNew(pd);
    gwLabelTitle(qualityContentLabel,"Content Type");
    gwLabelFrame(qualityContentLabel, 10, 6, 160, 17);
    gwLabelFont (qualityContentLabel, font);
    gwLabelAlign(qualityContentLabel, gwALIGN_H_CENTER);

    /*** Quality Content drop down widget                                                                   */
    /*** .................................................................................................. */
    qualityContentSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(qualityContentSelect, gwRed);
    for (idx = 0; idx < OP_CT_EOL; idx++)
        gwDropListAddItem(qualityContentSelect, opCntTyp[idx]);
    qualityContentNum = idx;
    gwDropListFrame(qualityContentSelect, 10, 25,160, windowMetric.dropList.height);
    qcsdx = 0;
    gwDropListSelectItem(qualityContentSelect,qcsdx);
    gwDropListSetItemColor(qualityContentSelect, qcsdx, QColor(0xAEDCE6));
    gwConnect(QualityCallBack, qualityContentSelect,currentIndexChanged(int));

    /*** Quality Quality Label                                                                              */
    /*** .................................................................................................. */
    qualityQualityLabel = gwLabelNew(pd);
    gwLabelTitle(qualityQualityLabel,"Print Quality");
    gwLabelFrame(qualityQualityLabel, 10, 66, 160, 17);
    gwLabelFont (qualityQualityLabel, font);
    gwLabelAlign(qualityQualityLabel, gwALIGN_H_CENTER);

    /*** Quality Quality drop down widget                                                                   */
    /*** .................................................................................................. */
    qualityQualitySelect = gwDropListNew(pd);
    gwDropListSetSelectColor(qualityQualitySelect, gwRed);
    for (idx = 0; idx < OP_PQ_EOL; idx++)
        gwDropListAddItem(qualityQualitySelect, opPrtQal[idx]);
    qualityQualityNum = idx;
    gwDropListFrame(qualityQualitySelect, 10, 85,160, windowMetric.dropList.height);
    qqsdx = 0;
    gwDropListSelectItem(qualityQualitySelect,qqsdx);
    gwDropListSetItemColor(qualityQualitySelect, qqsdx, QColor(0xAEDCE6));
    gwConnect(QualityCallBack, qualityQualitySelect,currentIndexChanged(int));

    /*** Quality Dpi Label                                                                                  */
    /*** .................................................................................................. */
    qualityDpiLabel = gwLabelNew(pd);
    gwLabelTitle(qualityDpiLabel,"Print Dpi");
    gwLabelFrame(qualityDpiLabel, 10, 126, 160, 17);
    gwLabelFont (qualityDpiLabel, font);
    gwLabelAlign(qualityDpiLabel, gwALIGN_H_CENTER);

    /*** Quality Dpi drop down widget                                                                       */
    /*** .................................................................................................. */
    qualityDpiSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(qualityDpiSelect, gwRed);
//    for (idx = 0; cellPhoneSize[idx+1] != NULL; idx++)
        gwDropListAddItem(qualityDpiSelect,"test");
    qualityDpiNum = 1;
    gwDropListFrame(qualityDpiSelect, 10, 145,160, windowMetric.dropList.height);
    qdsdx = 0;
    gwDropListSelectItem(qualityDpiSelect,qqsdx);
    gwDropListSetItemColor(qualityDpiSelect, qqsdx, QColor(0xAEDCE6));
    gwConnect(QualityCallBack, qualityDpiSelect,currentIndexChanged(int));

    /*** Quality Color System Label                                                                         */
    /*** .................................................................................................. */
    qualityColorSystemLabel = gwLabelNew(pd);
    gwLabelTitle(qualityColorSystemLabel,"Color System");
    gwLabelFrame(qualityColorSystemLabel, 10, 186, 160, 17);
    gwLabelFont (qualityColorSystemLabel, font);
    gwLabelAlign(qualityColorSystemLabel, gwALIGN_H_CENTER);

    /*** Quality Color System drop down widget                                                              */
    /*** .................................................................................................. */
    qualityColorSystemSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(qualityColorSystemSelect, gwRed);
    for (idx = 0; idx < OP_CS_EOL; idx++)
        gwDropListAddItem(qualityColorSystemSelect, opColSys[idx]);
    qualityColorSystemNum = idx;
    gwDropListFrame(qualityColorSystemSelect, 10, 205,160, windowMetric.dropList.height);
    qcssdx = 0;
    gwDropListSelectItem(qualityColorSystemSelect,qcssdx);
    gwDropListSetItemColor(qualityColorSystemSelect, qcssdx, QColor(0xAEDCE6));
    gwConnect(QualityCallBack, qualityColorSystemSelect,currentIndexChanged(int));

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreateQualityDialog(...)                                                                              */

/* ======================================================================================================== */
/* Function name: _CreatePrintAreaDialog(...)                                                               */
/* ======================================================================================================== */
static gpVOID _CreatePrintAreaDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwDIALOG* pd;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Media Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Print Area");
    gwDialogFrame(pd, 428, 562, 210, 350);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreatePrintAreaDialog(...)                                                                            */

/* ======================================================================================================== */
/* Function name: _CreateOutputDialog(...)                                                                  */
/* ======================================================================================================== */
static gpVOID _CreateOutputDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwDIALOG* pd;
gpINT32   idx;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Media Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Output");
    gwDialogFrame(pd, 642, 562, 210, 350);

    /*** Output Bin Label                                                                                   */
    /*** .................................................................................................. */
    outputBinLabel = gwLabelNew(pd);
    gwLabelTitle(outputBinLabel,"Output Bin");
    gwLabelFrame(outputBinLabel, 10, 6, 160, 17);
    gwLabelFont (outputBinLabel, font);
    gwLabelAlign(outputBinLabel, gwALIGN_H_CENTER);

    /*** Output Bin drop down widget                                                                        */
    /*** .................................................................................................. */
    outputBinSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(outputBinSelect, gwRed);
    for (idx = 0; idx < OP_OB_EOL; idx++)
        gwDropListAddItem(outputBinSelect, opOutBin[idx]);
    outputBinNum = idx;
    gwDropListFrame(outputBinSelect, 10, 25,160, windowMetric.dropList.height);
    obsdx = 0;
    gwDropListSelectItem(outputBinSelect,obsdx);
    gwDropListSetItemColor(outputBinSelect, obsdx, QColor(0xAEDCE6));
    gwConnect(OutputCallBack, outputBinSelect,currentIndexChanged(int));

    /*** Output Jog Label                                                                                   */
    /*** .................................................................................................. */
    outputJogLabel = gwLabelNew(pd);
    gwLabelTitle(outputJogLabel,"Jog Output");
    gwLabelFrame(outputJogLabel, 10, 66, 160, 17);
    gwLabelFont (outputJogLabel, font);
    gwLabelAlign(outputJogLabel, gwALIGN_H_CENTER);

    /*** Output Jog drop down widget                                                                        */
    /*** .................................................................................................. */
    outputJogSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(outputJogSelect, gwRed);
    for (idx = 0; idx < OP_JO_EOL; idx++)
        gwDropListAddItem(outputJogSelect, opJogOff[idx]);
    outputJogNum = idx;
    gwDropListFrame(outputJogSelect, 10, 85,160, windowMetric.dropList.height);
    ojsdx = 0;
    gwDropListSelectItem(outputJogSelect,ojsdx);
    gwDropListSetItemColor(outputJogSelect, ojsdx, QColor(0xAEDCE6));
    gwConnect(OutputCallBack, outputJogSelect,currentIndexChanged(int));

    /*** Output Separator Sheet Label                                                                       */
    /*** .................................................................................................. */
    outputSeparatorLabel = gwLabelNew(pd);
    gwLabelTitle(outputSeparatorLabel,"Separator Sheet");
    gwLabelFrame(outputSeparatorLabel, 10, 126, 160, 17);
    gwLabelFont (outputSeparatorLabel, font);
    gwLabelAlign(outputSeparatorLabel, gwALIGN_H_CENTER);

    /*** Output Separator Sheet drop down widget                                                            */
    /*** .................................................................................................. */
    outputSeparatorSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(outputSeparatorSelect, gwRed);
    for (idx = 0; idx < OP_SS_EOL; idx++)
        gwDropListAddItem(outputSeparatorSelect, opSepSht[idx]);
    outputSeparatorNum = idx;
    gwDropListFrame(outputSeparatorSelect, 10, 145,160, windowMetric.dropList.height);
    ossdx = 0;
    gwDropListSelectItem(outputSeparatorSelect,ossdx);
    gwDropListSetItemColor(outputSeparatorSelect, ossdx, QColor(0xAEDCE6));
    gwConnect(OutputCallBack, outputSeparatorSelect,currentIndexChanged(int));

    /*** Output Collate Label                                                                               */
    /*** .................................................................................................. */
    outputCollateLabel = gwLabelNew(pd);
    gwLabelTitle(outputCollateLabel,"Collate");
    gwLabelFrame(outputCollateLabel, 10, 186, 160, 17);
    gwLabelFont (outputCollateLabel, font);
    gwLabelAlign(outputCollateLabel, gwALIGN_H_CENTER);

    /*** Output Collate drop down widget                                                                    */
    /*** .................................................................................................. */
    outputCollateSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(outputCollateSelect, gwRed);
    for (idx = 0; idx < OP_CT_EOL; idx++)
        gwDropListAddItem(outputCollateSelect, opCltTyp[idx]);
    outputCollateNum = idx;
    gwDropListFrame(outputCollateSelect, 10, 205,160, windowMetric.dropList.height);
    ocsdx = 0;
    gwDropListSelectItem(outputCollateSelect,ocsdx);
    gwDropListSetItemColor(outputCollateSelect, ocsdx, QColor(0xAEDCE6));
    gwConnect(OutputCallBack, outputCollateSelect,currentIndexChanged(int));

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreateOutputDialog(...)                                                                               */

/* ======================================================================================================== */
/* Function name: _CreateFinishingDialog(...)                                                               */
/* ======================================================================================================== */
static gpVOID _CreateFinishingDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwDIALOG* pd;
gpINT32   idx;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Media Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Finishing");
    gwDialogFrame(pd, 856, 562, 210, 350);

    /*** Finishing Folding Label                                                                            */
    /*** .................................................................................................. */
    finishingFoldingLabel = gwLabelNew(pd);
    gwLabelTitle(finishingFoldingLabel,"Folding");
    gwLabelFrame(finishingFoldingLabel, 10, 6, 160, 17);
    gwLabelFont (finishingFoldingLabel, font);
    gwLabelAlign(finishingFoldingLabel, gwALIGN_H_CENTER);

    /*** Finishing Folding drop down widget                                                                 */
    /*** .................................................................................................. */
    finishingFoldingSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(finishingFoldingSelect, gwRed);
    for (idx = 0; idx < OP_FD_EOL; idx++)
        gwDropListAddItem(finishingFoldingSelect, opFldTyp[idx]);
    finishingFoldingNum = idx;
    gwDropListFrame(finishingFoldingSelect, 10, 25,160, windowMetric.dropList.height);
    ffsdx = 0;
    gwDropListSelectItem(finishingFoldingSelect,ffsdx);
    gwDropListSetItemColor(finishingFoldingSelect, ffsdx, QColor(0xAEDCE6));
    gwConnect(FinishingCallBack, finishingFoldingSelect,currentIndexChanged(int));

    /*** Finishing Stitching Label                                                                          */
    /*** .................................................................................................. */
    finishingStitchingLabel = gwLabelNew(pd);
    gwLabelTitle(finishingStitchingLabel,"Stitching");
    gwLabelFrame(finishingStitchingLabel, 10, 66, 160, 17);
    gwLabelFont (finishingStitchingLabel, font);
    gwLabelAlign(finishingStitchingLabel, gwALIGN_H_CENTER);

    /*** Finishing Stitching drop down widget                                                               */
    /*** .................................................................................................. */
    finishingStitchingSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(finishingStitchingSelect, gwRed);
    for (idx = 0; idx < OP_ST_EOL; idx++)
        gwDropListAddItem(finishingStitchingSelect, opSchTyp[idx]);
    finishingStitchingNum = idx;
    gwDropListFrame(finishingStitchingSelect, 10, 85,160, windowMetric.dropList.height);
    fssdx = 0;
    gwDropListSelectItem(finishingStitchingSelect,fssdx);
    gwDropListSetItemColor(finishingStitchingSelect, fssdx, QColor(0xAEDCE6));
    gwConnect(FinishingCallBack, finishingStitchingSelect,currentIndexChanged(int));

    /*** Finishing Binding Label                                                                            */
    /*** .................................................................................................. */
    finishingBindingLabel = gwLabelNew(pd);
    gwLabelTitle(finishingBindingLabel,"Binding");
    gwLabelFrame(finishingBindingLabel, 10, 126, 160, 17);
    gwLabelFont (finishingBindingLabel, font);
    gwLabelAlign(finishingBindingLabel, gwALIGN_H_CENTER);

    /*** Finishing Binding drop down widget                                                                 */
    /*** .................................................................................................. */
    finishingBindingSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(finishingBindingSelect, gwRed);
    for (idx = 0; idx < OP_BT_EOL; idx++)
        gwDropListAddItem(finishingBindingSelect, opBndTyp[idx]);
    finishingBindingNum = idx;
    gwDropListFrame(finishingBindingSelect, 10, 145,160, windowMetric.dropList.height);
    fbsdx = 0;
    gwDropListSelectItem(finishingBindingSelect,fbsdx);
    gwDropListSetItemColor(finishingBindingSelect, fbsdx, QColor(0xAEDCE6));
    gwConnect(FinishingCallBack, finishingBindingSelect,currentIndexChanged(int));

    /*** Finishing Holes Label                                                                              */
    /*** .................................................................................................. */
    finishingHolesLabel = gwLabelNew(pd);
    gwLabelTitle(finishingHolesLabel,"Holes");
    gwLabelFrame(finishingHolesLabel, 10, 186, 160, 17);
    gwLabelFont (finishingHolesLabel, font);
    gwLabelAlign(finishingHolesLabel, gwALIGN_H_CENTER);

    /*** Finishing Holes drop down widget                                                                   */
    /*** .................................................................................................. */
    finishingHolesSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(finishingHolesSelect, gwRed);
    //for (idx = 0; idx < OP_; idx++)
        gwDropListAddItem(finishingHolesSelect,"test");
    finishingHolesNum = 1;
    gwDropListFrame(finishingHolesSelect, 10, 205,160, windowMetric.dropList.height);
    fhsdx = 0;
    gwDropListSelectItem(finishingHolesSelect,fhsdx);
    gwDropListSetItemColor(finishingHolesSelect, fhsdx, QColor(0xAEDCE6));
    gwConnect(FinishingCallBack, finishingHolesSelect,currentIndexChanged(int));

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreateFinishingDialog(...)                                                                            */

/* ======================================================================================================== */
/* Function name: _CreateNotificationDialog(...)                                                            */
/* ======================================================================================================== */
static gpVOID _CreateNotificationDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwDIALOG* pd;
gpINT32   idx;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Media Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Notification");
    gwDialogFrame(pd, 1070, 562, 210, 350);

    /*** Notification Events Label                                                                          */
    /*** .................................................................................................. */
    notificationEventsLabel = gwLabelNew(pd);
    gwLabelTitle(notificationEventsLabel,"Notify Events");
    gwLabelFrame(notificationEventsLabel, 10, 6, 160, 17);
    gwLabelFont (notificationEventsLabel, font);
    gwLabelAlign(notificationEventsLabel, gwALIGN_H_CENTER);

    /*** Notification Events drop down widget                                                               */
    /*** .................................................................................................. */
    notificationEventsSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(notificationEventsSelect, gwRed);
    for (idx = 0; idx < OP_ES_EOL; idx++)
        gwDropListAddItem(notificationEventsSelect, opEvtSub[idx]);
    notificationEventsNum = idx;
    gwDropListFrame(notificationEventsSelect, 10, 25,160, windowMetric.dropList.height);
    nesdx = 0;
    gwDropListSelectItem(notificationEventsSelect,nesdx);
    gwDropListSetItemColor(notificationEventsSelect, nesdx, QColor(0xAEDCE6));
    gwConnect(NotificationCallBack, notificationEventsSelect,currentIndexChanged(int));

    /*** Notification Hold For/Till Label                                                                   */
    /*** .................................................................................................. */
    notificationHoldLabel = gwLabelNew(pd);
    gwLabelTitle(notificationHoldLabel,"Hold For/Till");
    gwLabelFrame(notificationHoldLabel, 10, 66, 160, 17);
    gwLabelFont (notificationHoldLabel, font);
    gwLabelAlign(notificationHoldLabel, gwALIGN_H_CENTER);

    /*** Notification Hold For/Till drop down widget                                                        */
    /*** .................................................................................................. */
    notificationHoldSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(notificationHoldSelect, gwRed);
    for (idx = 0; idx < OP_HD_EOL; idx++)
        gwDropListAddItem(notificationHoldSelect, opHldTyp[idx]);
    notificationHoldNum = idx;
    gwDropListFrame(notificationHoldSelect, 10, 85,160, windowMetric.dropList.height);
    nhsdx = 0;
    gwDropListSelectItem(notificationHoldSelect,nhsdx);
    gwDropListSetItemColor(notificationHoldSelect, nhsdx, QColor(0xAEDCE6));
    gwConnect(NotificationCallBack, notificationHoldSelect,currentIndexChanged(int));

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreateNotificationDialog(...)                                                                         */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ======================================== op.more.dialog.c ============================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
