/* ======================================= op.print.dialog.c ============================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                        Author: Glen Petrie                                               */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2011-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing                                                                      */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#define NO_ANOTHER_WINDOW_CONTROLLER  0

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "op.print.dialog.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */
#define Show(o) \
    fprintf(stderr,"QObject: %s: %d\n", o, senderId); fflush(stderr);

    /*** Print Icon Elements (PIE)                                                                          */
    /*** .................................................................................................. */
    /*** WARNING WARNING Order is important.  The system renders in order defined.                          */
    /*** .................................................................................................. */
typedef enum {
    gwBW_Page = 0,
    gwBW_Duplex,
    gwBW_MarginBottomArrow,
    gwBW_MarginLeftArrow,
    gwBW_MarginRightArrow,
    gwBW_MarginTopArrow,
    gwBW_Binding,
    gwBW_NUp,
    gwBW_Orient,
    gwBW_Scale,
    gwCLR_Page,
    gwCLR_Duplex,
    gwCLR_MarginBottomArrow,
    gwCLR_MarginLeftArrow,
    gwCLR_MarginRightArrow,
    gwCLR_MarginTopArrow,
    gwCLR_Binding,
    gwCLR_NUp,
    gwCLR_Orient,
    gwCLR_Scale
} PIE;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */
opJobTicket*  myJobTicket;

/* ----------------------------------- Graphic Elements for Main Window ----------------------------------- */
/* ..................................................|..................................................... */
    gwDIALOG*       PrintDialog;

    gwPUSHBUTTON*   printButton;
    gwPUSHBUTTON*   cancelButton;

    gwDROPLIST*     printerSelect;
        gpBIT32     ptrsdx;

    gwLABEL*        pagesLabel;
        gwRADIOBUTTONGROUP* pagesGroup;
            gwRADIOBUTTON*  allPagesButton;
            gwRADIOBUTTON*  selectPagesButton;
        gwEDITLINE*     selectedPageEdit;

    gwLABEL*        copiesLabel;
        gwCOUNTBOX*     numCopiesCnt;

    gwCHECKBOX*     twoSidedCheck;

    gwLABEL*        orientationLabel;
        gwRADIOBUTTONGROUP* orientationGroup;
            gwRADIOBUTTON*  portraitButton;
            gwRADIOBUTTON*  landscapeButton;

    gwLABEL*        colorLabel;
        gwRADIOBUTTONGROUP* colorGroup;
            gwRADIOBUTTON*  colorButton;
            gwRADIOBUTTON*  blackWhiteButton;

    gwLINK*         moreLink;
    gpBOOL          moreFlag;

    gwICON*         pie[40];
        gpBIT8          pieBW_CLR;
        gpBIT8          pieFlag[10];

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */
static gpVOID _CreatePrintDialog    (gwDIALOG**);
static gpVOID _CreatePrintIconShapes(gwDIALOG* );

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/* ======================================================================================================== */
/* Function name: opPrintDialog(...)                                                                        */
/* ======================================================================================================== */
gwDIALOG* opPrintDialog(

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
//opERR_CODE  status;

    Prt("### Starting Mobile Print Dialog Demonstration ###\n");

/*** Initialize Global Variables                                                                            */
/*** ------------------------------------------------------------------------------------------------------ */
    moreFlag = gpFALSE;

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Create a new Job Ticket                                                                                */
/*** ------------------------------------------------------------------------------------------------------ */
    //status = opJobTicketNew(&myJobTicket);

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */
#if NO_ANOTHER_WINDOW_CONTROLLER
    gwWindowInitialize (argc, argv);
#endif
    gwSetCallBackFncNew(PrintDialogCallBack);

/*** Create Mobile Print Dialog                                                                             */
/*** ------------------------------------------------------------------------------------------------------ */
    moreFlag = gpFALSE;
    _CreatePrintDialog(&PrintDialog);

/*** Show (Display) Windows and Dialogs                                                                     */
/*** ------------------------------------------------------------------------------------------------------ */
    gwDialogShow(PrintDialog);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return(PrintDialog);

} /* main(...)                                                                                              */

/* ======================================================================================================== */
/* Function name: PrintDialogCallBack                                                                       */
/* ======================================================================================================== */
gpVOID PrintDialogCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;
gpINT32 idx;

/*** Initialize Global Variables                                                                            */
/*** ------------------------------------------------------------------------------------------------------ */
senderId = (gpBIT32)sender;

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (true) {

    /*** Print Button                                                                                       */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)printButton) {
      Show("Print Button");
      break;
    }

    /*** Cancel Button                                                                                      */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)cancelButton) {
      Show("Cancel Button");
      if (moreFlag == gpTRUE) { MoreClose(); moreFlag = gpFALSE; }
      gwDialogClose(PrintDialog);
      return;
      break;
    }

    /*** Printer Selection                                                                                  */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)printerSelect) {
      Show("Printer Select");
      gwDropListSetItemColor(printerSelect, ptrsdx, gwNone);
      ptrsdx = gwDropListGetIndex(printerSelect);
      gwDropListSetItemColor(printerSelect, ptrsdx, QColor(0xAEDCE6));
      break;
    }

    /*** All Pages Button                                                                                   */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)allPagesButton) {
      Show("All Pages Button");
      break;
    }

    /*** Selected Pages Button                                                                              */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)selectPagesButton) {
      Show("Selected Pages Button");
      break;
    }

    /*** Selected Pages Edit Field                                                                          */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)selectedPageEdit) {
      Show("Selected Pages Edit Field");
      break;
    }

    /*** Number of Copies                                                                                   */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)numCopiesCnt) {
      Show("Number of Copies");
      break;
    }

    /*** Two Sided Check Box                                                                                */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId ==  (gpBIT32)twoSidedCheck) {
      pieFlag[gwBW_Duplex] ^= 1;
      Show("Two Sides Check Box");
      break;
    }

    /*** Portrait Button                                                                                    */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)portraitButton) {
      pieFlag[gwBW_Orient] = 0;
      Show("Portrait Button");
      break;
    }

    /*** Landscape Button                                                                                   */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)landscapeButton) {
      pieFlag[gwBW_Orient] = 1;
      Show("Landscape Button");
      break;
    }

    /*** Color Button                                                                                       */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)colorButton) {
      pieBW_CLR = gwCLR_Page;
      Show("Color Button");
      break;
    }

    /*** Black / White Button                                                                               */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)blackWhiteButton) {
      pieBW_CLR = gwBW_Page;
      Show("Black / White Button");
      break;
    }

    /*** More Link                                                                                          */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)moreLink) {
      Show("More... Link");
      if (moreFlag == gpTRUE) { MoreClose(); moreFlag = gpFALSE;  }
      else                    { More();      moreFlag = gpTRUE; }
      break;
    }

    if (senderId == (gpBIT32)NULL) {
      Show("Close");
      //if (moreFlag == gpTRUE) { MoreClose(); moreFlag = gpFALSE;  }
      //else                    { More();      moreFlag = gpTRUE; }
      break;
    }

    /*** What happened - Error occurred                                                                     */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

    /*** Update the Print Icon                                                                              */
    /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    for (idx = 0; idx < 20; idx++) { gwIconShow(pie[idx], false); }
    for (idx = 0; idx < 10; idx++)
      { gwIconShow(pie[idx+pieBW_CLR], pieFlag[idx]); }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* PrintDialogCallBack(...)                                                                               */

/* ======================================================================================================== */
/* Function name: _CreatePrintDialog(...)                                                                   */
/* ======================================================================================================== */
static gpVOID _CreatePrintDialog(

    gwDIALOG** pdRet

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwFONT*   font;
gwDIALOG* pd;

/*** Initialize Global Variables                                                                            */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Set Title and Size of the Print Dialog                                                                 */
/*** ------------------------------------------------------------------------------------------------------ */
    pd = gwDialogNew();
    gwDialogTitle(pd,"Dialog");
    gwDialogFrame(pd, 700, 100, 240, 352);

/*** Set Sub-Elements of the Print Dialog                                                                   */
/*** ------------------------------------------------------------------------------------------------------ */
    /*** "Print"/"Cancel" Push Button                                                                       */
    /*** .................................................................................................. */
    printButton = gwPushButtonNew(pd);
    gwPushButtonTitle  (printButton,"Print" );
    gwPushButtonFrame  (printButton, 81, 14, 131, 27);
    gwPushButtonConnect(PrintDialogCallBack,printButton, clicked());

    cancelButton = gwPushButtonNew(pd);
    gwPushButtonTitle  (cancelButton,"Cancel");
    gwPushButtonFrame  (cancelButton, 81, 50, 131, 27);
    gwPushButtonConnect(PrintDialogCallBack,cancelButton, clicked());

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    /*** "Printer Select" Drop List                                                                         */
    /*** .................................................................................................. */
    printerSelect = gwDropListNew(pd);
    gwDropListSetSelectColor(printerSelect, gwRed);
    gwDropListFrame     (printerSelect, 10, 90, 201, 31);
    gwDropListAddItem   (printerSelect,"EPSON B-500DN");
    gwDropListAddItem   (printerSelect,"Test 1");
    gwDropListAddItem   (printerSelect,"Test 2");
    ptrsdx = 0;
    gwDropListSelectItem(printerSelect, ptrsdx);
    gwDropListSetItemColor(printerSelect, ptrsdx, QColor(0xAEDCE6));
    gwDropListConnect   (PrintDialogCallBack,printerSelect,
                                            currentIndexChanged(int));

    /*** Define Font for Text Labels                                                                        */
    /*** .................................................................................................. */
    font = gwFontNew(pd);
    gwFontSize(font, 11);
    gwFontBold(font);

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    /*** "Pages" Text Label                                                                                 */
    /*** .................................................................................................. */
    pagesLabel = gwLabelNew(pd);
    gwLabelTitle(pagesLabel,"Pages");
    gwLabelFrame(pagesLabel, 80, 133, 64, 17);
    gwLabelFont (pagesLabel, font);
    gwLabelAlign(pagesLabel, gwALIGN_H_CENTER);

    /*** "All Pages" Radio Button                                                                           */
    /*** .................................................................................................. */
    allPagesButton = gwRadioButtonNew(pd);
    gwRadioButtonTitle  (allPagesButton,"All");
    gwRadioButtonFrame  (allPagesButton, 10, 130, 71, 22);
    gwRadioButtonChecked(allPagesButton, true);
    gwRadioButtonConnect(PrintDialogCallBack,allPagesButton, clicked());

    /*** "Select Pages" Radio Button                                                                        */
    /*** .................................................................................................. */
    selectPagesButton = gwRadioButtonNew(pd);
    gwRadioButtonTitle  (selectPagesButton,"");
    gwRadioButtonFrame  (selectPagesButton, 10, 150, 181, 22);
    gwRadioButtonChecked(selectPagesButton, false);
    gwRadioButtonConnect(PrintDialogCallBack,selectPagesButton, clicked());

    /*** "Pages" Group                                                                                      */
    /*** .................................................................................................. */
    pagesGroup = gwRadioButtonGroupNew(pd);
    gwRadioButtonGroupAdd(pagesGroup, allPagesButton);
    gwRadioButtonGroupAdd(pagesGroup, selectPagesButton);

    /*** "Select Pages" Edit Line                                                                           */
    /*** .................................................................................................. */
    selectedPageEdit = gwEditLineNew(pd);
    gwEditLineFrame  (selectedPageEdit, 30, 150, 181, 21);
    gwEditLineConnect(PrintDialogCallBack,selectedPageEdit, textChanged());

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    /*** "Number of Copies" Counter                                                                         */
    /*** .................................................................................................. */
    numCopiesCnt = gwCountBoxNew(pd);
    gwCountBoxFrame  (numCopiesCnt, 44, 181, 71, 27);
    gwCountBoxRange  (numCopiesCnt, 1, 99);
    gwCountBoxConnect(PrintDialogCallBack,numCopiesCnt, valueChanged(int));

    /*** "Copies" Text Label                                                                                */
    /*** .................................................................................................. */
    copiesLabel = gwLabelNew(pd);
    gwLabelTitle(copiesLabel,"Copies");
    gwLabelFrame(copiesLabel, 122, 187, 64, 17);
    gwLabelFont (copiesLabel, font);
    gwLabelAlign(copiesLabel, gwALIGN_H_CENTER);

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    twoSidedCheck = gwCheckBoxNew(pd);
    gwCheckBoxTitle  (twoSidedCheck," Two-Sided");
    gwCheckBoxFrame  (twoSidedCheck, 100, 211, 111, 22);
    gwCheckBoxFont   (twoSidedCheck, font);
    gwCheckBoxConnect(PrintDialogCallBack,twoSidedCheck, clicked());

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    /*** "Orientation" Text Label                                                                           */
    /*** .................................................................................................. */
    orientationLabel = gwLabelNew(pd);
    gwLabelTitle(orientationLabel,"Orientation");
    gwLabelFrame(orientationLabel, 60, 234, 101, 20);
    gwLabelFont (orientationLabel, font);
    gwLabelAlign(orientationLabel, gwALIGN_H_CENTER);

    /*** "Portrait" Orientation Radio Button                                                                */
    /*** .................................................................................................. */
    portraitButton = gwRadioButtonNew(pd);
    gwRadioButtonTitle  (portraitButton,"Portrait");
    gwRadioButtonFrame  (portraitButton, 11, 251, 79, 22);
    gwRadioButtonChecked(portraitButton, true);
    gwRadioButtonConnect(PrintDialogCallBack,portraitButton, clicked());

    /*** "Landscape" Orientation Radio Button                                                               */
    /*** .................................................................................................. */
    landscapeButton = gwRadioButtonNew(pd);
    gwRadioButtonTitle  (landscapeButton,"Landscape");
    gwRadioButtonFrame  (landscapeButton, 112, 251, 98, 22);
    gwRadioButtonChecked(landscapeButton, false);
    gwRadioButtonConnect(PrintDialogCallBack,landscapeButton, clicked());

    /*** "Orientation" Group                                                                                */
    /*** .................................................................................................. */
    orientationGroup = gwRadioButtonGroupNew(pd);
    gwRadioButtonGroupAdd(orientationGroup, portraitButton);
    gwRadioButtonGroupAdd(orientationGroup, landscapeButton);

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    /*** "Color" Text Label                                                                                 */
    /*** .................................................................................................. */
    colorLabel = gwLabelNew(pd);
    gwLabelTitle(colorLabel,"Color");
    gwLabelFrame(colorLabel, 80, 281, 64, 17);
    gwLabelFont (colorLabel, font);
    gwLabelAlign(colorLabel, gwALIGN_H_CENTER);

    /*** "Black/White" Color Radio Button                                                                   */
    /*** .................................................................................................. */
    blackWhiteButton = gwRadioButtonNew(pd);
    gwRadioButtonTitle  (blackWhiteButton,"Black / White");
    gwRadioButtonFrame  (blackWhiteButton, 11, 296, 115, 22);
    gwRadioButtonChecked(blackWhiteButton, true);
    gwRadioButtonConnect(PrintDialogCallBack,blackWhiteButton, clicked());

    /*** "Color" Color Radio Button                                                                         */
    /*** .................................................................................................. */
    colorButton = gwRadioButtonNew(pd);
    gwRadioButtonTitle  (colorButton,"Color");
    gwRadioButtonFrame  (colorButton, 132, 296, 65, 22);
    gwRadioButtonChecked(colorButton, false);
    gwRadioButtonConnect(PrintDialogCallBack,colorButton, clicked());

    /*** "Color" Group                                                                                      */
    /*** .................................................................................................. */
    colorGroup = gwRadioButtonGroupNew(pd);
    gwRadioButtonGroupAdd(colorGroup, blackWhiteButton);
    gwRadioButtonGroupAdd(colorGroup, colorButton);

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    /*** "More" Link                                                                                        */
    /*** .................................................................................................. */
    moreLink = gwLinkNew(pd);
    gwLinkTitle  (moreLink,"More . . . ");
    gwLinkFrame  (moreLink , 8, 315, 182, 31);
    gwLinkConnect(PrintDialogCallBack,moreLink, clicked());

/*** Create Print Icon                                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    _CreatePrintIconShapes(pd);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    *pdRet = pd;
    return;

} /* _CreatePrintDialog(...)                                                                                */

/* ======================================================================================================== */
/* Function name: _CreatePrintIconParts(...)                                                                */
/* ======================================================================================================== */
static gpVOID _CreatePrintIconShapes(

    gwDIALOG* pd

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 idx;

/*** Initialize Global Variables                                                                            */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */

    /*** Print Icon Elements (PIE)                                                                          */
    /*** .................................................................................................. */
const gpCHAR* pieFiles[] = {
                "./gwPrintIconElements/gwBW_Page.png",
                "./gwPrintIconElements/gwBW_Duplex.png",
                "./gwPrintIconElements/gwBW_MarginBottomArrow.png",
                "./gwPrintIconElements/gwBW_MarginLeftArrow.png",
                "./gwPrintIconElements/gwBW_MarginRightArrow.png",
                "./gwPrintIconElements/gwBW_MarginTopArrow.png",
                "./gwPrintIconElements/gwBW_Binding.png",
                "./gwPrintIconElements/gwBW_N-Up.png",
                "./gwPrintIconElements/gwBW_Orient.png",
                "./gwPrintIconElements/gwBW_Scale.png",
                "./gwPrintIconElements/gwCLR_Page.png",
                "./gwPrintIconElements/gwCLR_Duplex.png",
                "./gwPrintIconElements/gwCLR_MarginBottomArrow.png",
                "./gwPrintIconElements/gwCLR_MarginLeftArrow.png",
                "./gwPrintIconElements/gwCLR_MarginRightArrow.png",
                "./gwPrintIconElements/gwCLR_MarginTopArrow.png",
                "./gwPrintIconElements/gwCLR_Binding.png",
                "./gwPrintIconElements/gwCLR_N-Up.png",
                "./gwPrintIconElements/gwCLR_Orient.png",
                "./gwPrintIconElements/gwCLR_Scale.png"};

gpRECT pieSizeFrame[] = {
           /* t , l , b , r , w , h  */
            {  0,  0, 79, 61, 61, 79 }, /* gwBW_Page                                                        */
            { 61, 43, 78, 60, 17, 17 }, /* gwBW_Duplex                                                      */
            { 69, 26, 79, 36, 10, 10 }, /* gwBW_MarginBottomArrow                                           */
            { 40,  0, 50, 15, 15, 10 }, /* gwBW_MarginLeftArrow                                             */
            { 40, 52, 50, 61,  9, 10 }, /* gwBW_MarginRightArrow                                            */
            {  0, 26, 17, 36, 10, 17 }, /* gwBW_MarginTopArrow                                              */
            {  0,  3, 79, 11,  9, 79 }, /* gwBW_Binding                                                     */
            { 17, 15, 69, 52, 37, 52 }, /* gwBW_NUp                                                         */
            {  0,  0, 17, 19, 19, 17 }, /* gwBW_Orient                                                      */
            {  0, 43, 18, 61, 18, 18 }, /* gwBW_Scale                                                       */

            {  0,  0, 79, 61, 61, 79 }, /* gwCLR_Page                                                       */
            { 61, 43, 78, 60, 17, 17 }, /* gwCLR_Duplex                                                     */
            { 69, 26, 79, 36, 10, 10 }, /* gwCLR_MarginBottomArrow                                          */
            { 40,  0, 50, 15, 15, 10 }, /* gwCLR_MarginLeftArrow                                            */
            { 40, 52, 50, 61,  9, 10 }, /* gwCLR_MarginRightArrow                                           */
            {  0, 26, 17, 36, 10, 17 }, /* gwCLR_MarginTopArrow                                             */
            {  0,  3, 79, 11,  9, 79 }, /* gwCLR_Binding                                                    */
            { 17, 15, 69, 52, 37, 52 }, /* gwCLR_NUp                                                        */
            {  0,  0, 17, 19, 19, 17 }, /* gwCLR_Orient                                                     */
            {  0, 43, 18, 61, 18, 18 }  /* gwCLR_Scale                                                      */
        };
gpBIT32 pieLeftOffset = 12;
gpBIT32 pieTopOffset  =  6;

/*** Load Icons                                                                                             */
/*** ------------------------------------------------------------------------------------------------------ */
    for (idx = 0; idx < 20; idx++) {
      pie[idx] = gwIconNew(pd);
      gwIconImageFile(pie[idx], pieFiles[idx]);
      gwIconFrame(pie[idx], pieSizeFrame[idx].left + pieLeftOffset,
                            pieSizeFrame[idx].top  + pieTopOffset,
                            pieSizeFrame[idx].width,
                            pieSizeFrame[idx].height);
      gwIconShow(pie[idx], false);
    }

/*** Set the initial display state of the print icon                                                        */
/*** ------------------------------------------------------------------------------------------------------ */
    pieFlag[0] = 1;
    for (idx = 1; idx < 10; idx++) pieFlag[idx] = 0;
    pieBW_CLR = gwBW_Page;
    gwIconShow(pie[pieBW_CLR], true);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* _CreatePrintIconShapes(...)                                                                            */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ======================================= op.print.dialog.c ============================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
